var currentVersion; 
var interval;
var keyboard;
var mouse;
var trackpad;

// Called by HTML body element's onload event when the widget is ready to start
function load() {
    dashcode.setupParts();
    currentVersion = widget.system("defaults read ~/Library/Widgets/BatteryLevel.wdgt/Info CFBundleVersion", null).outputString;
    version.innerText += " " + currentVersion;
}

// Called when the widget has been shown
function show() {
    // Restart any timers that were stopped on hide
    cycle();
    interval = setInterval("cycle()", 10000);
    widget.system("/usr/bin/curl --connect 2 http://markusweimar.de/software/batterylevel.stable", updateCheck);
}

function cycle() {
    reset();
    updateKeyboard();
    updateMouse();
    updateTrackpad();
    resizeWindow();
    /*
    //DEBUG
    percent1.innerText = "100%";
    percent2.innerText = "100%";
    percent3.innerText = "100%";
    
    percent1.innerText = "13%";
    percent2.innerText = "42%";
    percent3.innerText = "7%";
    document.getElementById("indicator1").object.setValue(85);
    document.getElementById("indicator2").object.setValue(50);
    document.getElementById("indicator3").object.setValue(95);
    */
}

function resizeWindow() {
    var devices = 0;
    if (keyboard) {
        devices += 1;
    }
    if (mouse) {
        devices += 1;
    }
    if (trackpad) {
        devices += 1;
    }
    text4.style.visibility = "hidden";
    switch(devices) {
        case 0:
            window.resizeTo(232,86);
            frontImg.style.height = '86px';
            frontImg.style.width = '232px';
            text4.style.visibility = "visible";
            break;
        case 1:
            window.resizeTo(232,86);
            frontImg.style.height = '86px';
            frontImg.style.width = '232px';
            break;
        case 2:
            window.resizeTo(232,123);
            frontImg.style.height = '123px';
            frontImg.style.width = '232px';
            break;
        default:
            window.resizeTo(232,157);
            frontImg.style.height = '157px';
            frontImg.style.width = '232px';
    }
}

function reset() {
    keyboard = false;
    mouse = false;
    trackpad = false;
    
    text1.style.visibility = "hidden";
    text2.style.visibility = "hidden";
    text3.style.visibility = "hidden";

    document.getElementById("indicator1").style.visibility = "hidden";
    document.getElementById("indicator2").style.visibility = "hidden";
    document.getElementById("indicator3").style.visibility = "hidden";

    percent1.style.visibility = "hidden";
    percent2.style.visibility = "hidden";
    percent3.style.visibility = "hidden";
    
    image1.style.visibility = "hidden";
    image2.style.visibility = "hidden";
    image3.style.visibility = "hidden";
}

function updateKeyboard() {
    var batteryPercent;
    
    var output = widget.system("/usr/sbin/ioreg -d 12 -n AppleBluetoothHIDKeyboard | grep -E 'AppleBluetoothHIDKeyboard|.BatteryPercent. = [0-9]+'", null).outputString;
    
    try {
        if (output.match(/AppleBluetoothHIDKeyboard/)) {
            keyboard = true;
        }
    }
    catch(err) {}

    if (!keyboard) {
        output = widget.system("/usr/sbin/ioreg -d 12 -n IOAppleBluetoothHIDDriver | grep -E 'IOAppleBluetoothHIDDriver|.BatteryPercent. = [0-9]+|.ClassOfDevice. = [9600|9536]'", null).outputString;
        try {
            if (output.match(/IOAppleBluetoothHIDDriver/) && output.match(/.ClassOfDevice. = 9536/)) {
                keyboard = true;
                if (output.match(/.ClassOfDevice. = ..../).toString().match(/9600/)) {
                    keyPos = output.search("9536");
                    mousePos = output.search("9600");
                    if (keyPos > mousePos) {
                        output.replace(/.BatteryPercent. = \d+/, "");
                    }
                }
            }
        }
        catch(err) {}
    }
    
    if (keyboard) {
        text1.innerText = getLocalizedString("Keyboard:");
        try {
            batteryPercent = output.match(/.BatteryPercent. = \d+/);
            batteryPercent = batteryPercent[0].match(/\d+/);
            document.getElementById("indicator1").object.setValue((batteryPercent-100)*-1);
            percent1.innerText = batteryPercent + "%";
            image1.style.visibility = "hidden";
        }
        catch(err) {
            document.getElementById("indicator1").object.setValue(-1);
            percent1.innerText = "";
            image1.style.visibility = "visible";
        }
        text1.style.visibility = "visible";
        document.getElementById("indicator1").style.visibility = "visible";
        percent1.style.visibility = "visible";
    }
}

function updateMouse() {
    var batteryPercent;
    
    var output = widget.system("/usr/sbin/ioreg -d 12 -n BNBMouseDevice | grep -E 'BNBMouseDevice|.BatteryPercent. = [0-9]+'", null).outputString;
    //var output = widget.system("/bin/cat ~/Desktop/bl.txt | grep -E 'BNBMouseDevice|.BatteryPercent. = [0-9]+'", null).outputString;
    
    try {
        if (output.match(/BNBMouseDevice/)) {
            mouse = true;
        }
    }
    catch(err) {}
    
    if (!mouse) {
        output = widget.system("/usr/sbin/ioreg -d 12 -n AppleBluetoothHIDMouse | grep -E 'AppleBluetoothHIDMouse|.BatteryPercent. = [0-9]+'", null).outputString;
        try {
            if (output.match(/AppleBluetoothHIDMouse/)) {
                mouse = true;
            }
        }
        catch(err) {}
    }
        
    if (!mouse) {
        output = widget.system("/usr/sbin/ioreg -d 12 -n IOAppleBluetoothHIDDriver | grep -E 'IOAppleBluetoothHIDDriver|.BatteryPercent. = [0-9]+|.ClassOfDevice. = [9600|9536]'", null).outputString;
        try {
            if (output.match(/IOAppleBluetoothHIDDriver/) && output.match(/.ClassOfDevice. = 9600/)) {
                mouse = true;
                if (output.match(/.ClassOfDevice. = ..../).toString().match(/9536/)) {                    
                    keyPos = output.search("9536");
                    mousePos = output.search("9600");
                    if (keyPos < mousePos) {
                        output.replace(/.BatteryPercent. = \d+/, "");
                    }
                }
            }
        }
        catch(err) {}
    }
    
    if (mouse) {
        if (text1.innerText == "") {
            text1.innerText = getLocalizedString("Mouse:");
            try {
                batteryPercent = output.match(/.BatteryPercent. = \d+/);
                batteryPercent = batteryPercent[0].match(/\d+/);
                document.getElementById("indicator1").object.setValue((batteryPercent-100)*-1);
                percent1.innerText = batteryPercent + "%";
                image1.style.visibility = "hidden";
            }
            catch(err) {
                document.getElementById("indicator1").object.setValue(-1);
                percent1.innerText = "";
                image1.style.visibility = "visible";
            }
            text1.style.visibility = "visible";
            document.getElementById("indicator1").style.visibility = "visible";
            percent1.style.visibility = "visible";
        }
        else {
            text2.innerText = getLocalizedString("Mouse:");
            try {
                batteryPercent = output.match(/.BatteryPercent. = \d+/);
                batteryPercent = batteryPercent[0].match(/\d+/);
                document.getElementById("indicator2").object.setValue((batteryPercent-100)*-1);
                percent2.innerText = batteryPercent + "%";
                image2.style.visibility = "hidden";
            }
            catch(err) {
                document.getElementById("indicator2").object.setValue(-1);
                percent2.innerText = "";
                image2.style.visibility = "visible";
            }
            text2.style.visibility = "visible";
            document.getElementById("indicator2").style.visibility = "visible";
            percent2.style.visibility = "visible";
        }
    }
}

function updateTrackpad() {
    var batteryPercent;
    
    var output = widget.system("/usr/sbin/ioreg -d 12 -n BNBTrackpadDevice | grep -E 'BNBTrackpadDevice|.BatteryPercent. = [0-9]+'", null).outputString;
    
    try {
        if (output.match(/BNBTrackpadDevice/)) {
            trackpad = true;
        }
    }
    catch(err) {}

    if (trackpad) {
        if (text1.innerText == "") {
            text1.innerText = getLocalizedString("Trackpad:");
            try {
                batteryPercent = output.match(/.BatteryPercent. = \d+/);
                batteryPercent = batteryPercent[0].match(/\d+/);
                document.getElementById("indicator1").object.setValue((batteryPercent-100)*-1);
                percent1.innerText = batteryPercent + "%";
                image1.style.visibility = "hidden";
            }
            catch(err) {
                document.getElementById("indicator1").object.setValue(-1);
                percent1.innerText = "";
                image1.style.visibility = "visible";
            }
            text1.style.visibility = "visible";
            document.getElementById("indicator1").style.visibility = "visible";
            percent1.style.visibility = "visible";
        }
        else if (text2.innerText == "") {
            text2.innerText = getLocalizedString("Trackpad:");
            try {
                batteryPercent = output.match(/.BatteryPercent. = \d+/);
                batteryPercent = batteryPercent[0].match(/\d+/);
                document.getElementById("indicator2").object.setValue((batteryPercent-100)*-1);
                percent2.innerText = batteryPercent + "%";
                image2.style.visibility = "hidden";
            }
            catch(err) {
                document.getElementById("indicator2").object.setValue(-1);
                percent2.innerText = "";
                image2.style.visibility = "visible";
            }
            text2.style.visibility = "visible";
            document.getElementById("indicator2").style.visibility = "visible";
            percent2.style.visibility = "visible";

        }
        else {
            text3.innerText = getLocalizedString("Trackpad:");
            try {
                batteryPercent = output.match(/.BatteryPercent. = \d+/);
                batteryPercent = batteryPercent[0].match(/\d+/);
                document.getElementById("indicator3").object.setValue((batteryPercent-100)*-1);
                percent3.innerText = batteryPercent + "%";
                image3.style.visibility = "hidden";
            }
            catch(err) {
                document.getElementById("indicator3").object.setValue(-1);
                percent3.innerText = "";
                image3.style.visibility = "visible";
            }
            text3.style.visibility = "visible";
            document.getElementById("indicator3").style.visibility = "visible";
            percent3.style.visibility = "visible";
        }
    }
}

function updateCheck(output) {
    output = output.outputString;
    try {
        if (output[0] != "<") {
            if (output > parseFloat(currentVersion)) {
                imageUpdate.style.visibility = "visible";
            }
            else {
                imageUpdate.style.visibility = "hidden";
            }
        }
    }
    catch(err) {
        imageUpdate.style.visibility = "hidden";
    }
}

function showWebsite(event) {
    widget.openURL("http://markusweimar.de/software_en/batterylevel");
}

function showDownloadWebsite(event) {
    widget.openURL("http://markusweimar.de/software_en/batterylevel/download");
}

// Called when the widget has been hidden
function hide() {
    // Stop any timers to prevent CPU usage
    clearInterval(interval);
}

// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
function showBack(event) {
    window.resizeTo(232,157);
    hide();
    
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";
    
    show();
    
    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}



//////////////////////////////////////////////////////////////////////////////



//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

function reload(event) {
    show();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}